SystemOrganization addCategory: #'Mercury-Prototype-MetaLevel'!
SystemOrganization addCategory: #'Mercury-Prototype-Middleware'!
SystemOrganization addCategory: #'Mercury-Prototype-ReflectionFactory'!
SystemOrganization addCategory: #'Mercury-Prototype-SecurityPolicy'!
SystemOrganization addCategory: #'Mercury-Prototype-DebuggingSeed'!
SystemOrganization addCategory: #'Mercury-Prototype-Tests'!
SystemOrganization addCategory: #'Mercury-Prototype-MyProject'!
SystemOrganization addCategory: #'Mercury-Prototype-RunTimeDebuggingSupport'!

TestCase subclass: #SanityLocalTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-Tests'!

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:43'!
testExample1

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aPackageMirror := aRemoteEnvironmentMirror packageNamed: 'Graphics-Primitives'.
	aClassMirror := aPackageMirror classNamed: 'Point'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror objInstVarNamed: #x put: 100.
	anObjectMirror objInstVarNamed: #y put: 200.
	self assert: aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror.
	self assert: aPackageMirror class = PackageIntercessionMirror.
	self assert: aClassMirror class = ClassIntercessionMirror.
	self assert: anObjectMirror class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) objAsString  = '100'.
	self assert: (anObjectMirror objInstVarNamed: #y) objAsString  = '200'.! !

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:43'!
testExample2

	|aRemoteEnvironmentMirror responce|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aRemoteEnvironmentMirror evaluate: '3 / 0' onRemoteExceptionDo: [:aRemoteExceptionMirror | 
		self assert: aRemoteExceptionMirror class = ExceptionIntercessionMirror.
		LocalDebuggingClient debug: aRemoteExceptionMirror
	].
	
	responce := aRemoteEnvironmentMirror evaluate: '3+1' onRemoteExceptionDo: [:exMirror | ].
	self assert: (responce class = ObjectIntercessionMirror).
	self assert: (responce baseObject = 4).! !

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:44'!
testExample3

	"works remotely and locally only when it is not run as test"

	|aRemoteEnvironmentMirror exceptionMirror interruptedProcessMirror aTempObjMirror aContextMirror|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aRemoteEnvironmentMirror evaluate: '[ |x| 3 / 0. Transcript show: x. ] value' onRemoteExceptionDo: [:exMirror |
		interruptedProcessMirror := exMirror interruptedProcess.
		aContextMirror := interruptedProcessMirror contextAt: 2.
		aContextMirror tempNamed: 't1' put: 'Can you see me ?'.
		self assert: (aContextMirror tempNamed: 't1') baseObject = 'Can you see me ?'.
		interruptedProcessMirror over.
		interruptedProcessMirror proceed.
	]
	! !

!SanityLocalTests methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:44'!
testExample4

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection onLocalEnvironment.
	aPackageMirror := aRemoteEnvironmentMirror newPackageNamed: #NewPackage.
	self assert: (aRemoteEnvironmentMirror packageNamed: #NewPackage) class = PackageIntercessionMirror.
	aClassMirror := aPackageMirror newClassNamed: #NewClass.
	aClassMirror := aClassMirror ivs: #('x' 'y').	
	aClassMirror := aClassMirror addMethod: 'hypothesis: aNumber
														Transcript show: aNumber. 
														^ 3 / aNumber'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror perform: #hypothesis: withArguments: #(0) onRemoteExceptionDo: [:aRemoteExceptionMirror |
		 LocalDebuggingClient debug: aRemoteExceptionMirror.
		self assert: (aRemoteExceptionMirror class = ExceptionIntercessionMirror).
	].
	self assert: (anObjectMirror perform: #hypothesis: withArguments: #(3) onRemoteExceptionDo: [:exMirror | ]) baseObject = 1.! !

TestCase subclass: #TestAPIexamplesRemote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-Tests'!

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/28/2013 12:55'!
testExample1

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aPackageMirror := aRemoteEnvironmentMirror packageNamed: 'Graphics-Primitives'.
	aClassMirror := aPackageMirror classNamed: 'Point'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror objInstVarNamed: #x put: 100.
	anObjectMirror objInstVarNamed: #y put: 200.
	self assert: aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror.
	self assert: aPackageMirror class = PackageIntercessionMirror.
	self assert: aClassMirror class = ClassIntercessionMirror.
	self assert: anObjectMirror class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) class = ObjectIntercessionMirror.
	self assert: (anObjectMirror objInstVarNamed: #x) objAsString  = '100'.
	self assert: (anObjectMirror objInstVarNamed: #y) objAsString  = '200'.! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/12/2013 19:30'!
testExample2

	|aRemoteEnvironmentMirror responce|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror evaluate: '3 / 0' onRemoteExceptionDo: [:aRemoteExceptionMirror | 
		self assert: aRemoteExceptionMirror class = ExceptionIntercessionMirror.
		LocalDebuggingClient debug: aRemoteExceptionMirror
	].
	
	responce := aRemoteEnvironmentMirror evaluate: '3+1' onRemoteExceptionDo: [:exMirror | ].
	self assert: (responce class = ObjectIntercessionMirror).
	self assert: (responce baseObject = 4).! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/12/2013 19:30'!
testExample3

	"works remotely and locally only when it is not run as test"

	|aRemoteEnvironmentMirror exceptionMirror interruptedProcessMirror aTempObjMirror aContextMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror evaluate: '[ |x| 3 / 0. Transcript show: x. ] value' onRemoteExceptionDo: [:exMirror |
		interruptedProcessMirror := exMirror interruptedProcess.
		aContextMirror := interruptedProcessMirror contextAt: 2.
		aContextMirror tempNamed: 't1' put: 'Can you see me ?'.
		self assert: (aContextMirror tempNamed: 't1') baseObject = 'Can you see me ?'.
		interruptedProcessMirror over.
		interruptedProcessMirror proceed.
	]
	! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/12/2013 19:42'!
testExample4

	|aRemoteEnvironmentMirror aPackageMirror aClassMirror anObjectMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aPackageMirror := aRemoteEnvironmentMirror newPackageNamed: #NewPackage.
	self assert: (aRemoteEnvironmentMirror packageNamed: #NewPackage) class = PackageIntercessionMirror.
	aClassMirror := aPackageMirror newClassNamed: #NewClass.
	aClassMirror := aClassMirror ivs: #('x' 'y').	
	aClassMirror := aClassMirror addMethod: 'hypothesis: aNumber
														Transcript show: aNumber. 
														^ 3 / aNumber'.
	anObjectMirror := aClassMirror newInstance.
	anObjectMirror perform: #hypothesis: withArguments: #(0) onRemoteExceptionDo: [:aRemoteExceptionMirror |
		 LocalDebuggingClient debug: aRemoteExceptionMirror.
		self assert: (aRemoteExceptionMirror class = ExceptionIntercessionMirror).
	].
	self assert: (anObjectMirror perform: #hypothesis: withArguments: #(3) onRemoteExceptionDo: [:exMirror | ]) baseObject = 1.! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:13'!
testExceptionPush

	|aRemoteEnvironmentMirror pushedExceptionMirror|

	pushedExceptionMirror := nil.

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.
	aRemoteEnvironmentMirror onRemoteExceptionDo: [:aRemoteExceptionMirror | 
		LocalDebuggingClient debug: aRemoteExceptionMirror.
		pushedExceptionMirror := aRemoteExceptionMirror.
	].
	
	aRemoteEnvironmentMirror run: '3 / 0'. "otherside will unload debugging support"
	(Delay forSeconds: 10) wait.
	self assert: (pushedExceptionMirror class = ExceptionIntercessionMirror).! !

!TestAPIexamplesRemote methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/28/2013 11:51'!
testReflectionPolicy

	|aRemoteEnvironmentMirror|

	aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.	
	self assert: (aRemoteEnvironmentMirror class = EnvironmentIntercessionMirror).
	[
		aRemoteEnvironmentMirror := Reflection on: RemoteEnvironment @ '127.0.0.1:8081'.	
		self assert: (aRemoteEnvironmentMirror class = EnvironmentIntrospectionMirror).
	] forkWithIntrospectionReflectionPolicy.
	(Delay forSeconds: 2) wait.! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 11:53'!
handler

	^ handler! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 11:53'!
handler: aHandler

	handler := aHandler! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/2/2013 10:28'!
reflectionPolicy 

	^ reflectionPolicy ifNil: [^ IntercessionSecurityPolicy ]! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/2/2013 10:31'!
reflectionPolicy: aReflectionPolicy

	reflectionPolicy := aReflectionPolicy ! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/24/2013 14:41'!
unhandledException

	^ uException! !

!Process methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/24/2013 14:42'!
unhandledException: anException

	uException := anException ! !

!Exception methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 12:16'!
handlerProcess 

	^ handlerProcess! !

!Exception methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/10/2013 12:16'!
handlerProcess: aHandlerProcess

	handlerProcess := aHandlerProcess! !

!BlockClosure methodsFor: '*Mercury-Prototype' stamp: 'NickPapoulias 1/14/2013 14:14'!
forkWithIntrospectionReflectionPolicy

	^ self newProcess
			reflectionPolicy: IntrospectionSecurityPolicy;
			resume.! !

!Debugger methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/14/2013 12:54'!
contextStack 

	^ contextStack! !

Object subclass: #DebuggingSeed
	instanceVariableNames: ''
	classVariableNames: 'registeredRequestor'
	poolDictionaries: ''
	category: 'Mercury-Prototype-DebuggingSeed'!

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:30'!
authenticate

	"authentication is automatically handled by the middleware in the prototype see: Seamless authentication manager"
	
	self loadDebuggingSupport.
	
	^ Smalltalk globals! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/28/2013 20:13'!
interruptedProcesses

	^ DebuggingHandler allInstances collect: [:instance | instance process]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:22'!
loadDebuggingSupport

	(Smalltalk globals keys includes: #RunTimeDebuggingSupport) ifFalse: [

		Gofer it
			url: 'http://ss3.gemstone.com/ss/Mercury-Prototype' username: 'nickp' password: 'drift145';
			package: 'Mercury-Prototype-RunTimeDebuggingSupport';
			load.
			
	]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:31'!
newUnhandledExceptionFrom: aHandler

	self loadDebuggingSupport.

	registeredRequestor ifNotNil: [registeredRequestor newRemoteException: aHandler exception].! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 15:28'!
pushNewExceptionsTo: aRequestor

	registeredRequestor := aRequestor ! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 12:14'!
run: aString

	self unloadDebuggingSupport.
	[Compiler evaluate: aString] fork.! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/28/2013 20:13'!
unhandledExceptions 

	^ DebuggingHandler allInstances collect: [:instance | instance exception]! !

!DebuggingSeed class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 14:32'!
unloadDebuggingSupport

	Gofer it
		package: 'Mercury-Prototype-RunTimeDebuggingSupport';
		unload.! !

Object subclass: #EnvironmentIdentifier
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-ReflectionFactory'!

Object subclass: #LocalDebuggingClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MyProject'!

!LocalDebuggingClient class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 15:22'!
debug: aRemoteEnvironmentMirror ! !

!LocalDebuggingClient methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 14:21'!
debug: aRemoteEnvironmentMirror ! !

Object subclass: #MercurySeamlessDeamon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-Middleware'!

!MercurySeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/24/2012 15:57'!
initialize

	super initialize. 
	self shutDown.! !

!MercurySeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/24/2012 15:57'!
shutDown

	SeamlessDeamonManager default shutDown. ! !

!MercurySeamlessDeamon class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 12/24/2012 15:58'!
startUp

	SeamlessDeamonManager default startUp. ! !

Object subclass: #Mirror
	instanceVariableNames: 'baseObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

Mirror subclass: #ObjectIntrospectionMirror
	instanceVariableNames: 'runTimeSupportMirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ObjectIntrospectionMirror subclass: #ClassIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ClassIntrospectionMirror subclass: #ClassIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:43'!
addIv: anIvName! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
addMethod: aString

	runTimeSupportMirror addMethod: aString inClass: baseObject.! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
ivs: ivArray

	runTimeSupportMirror setIvs: ivArray forClass: baseObject! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:43'!
package: aPackageName! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:43'!
removeIv: anIvName! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:41'!
removeMethod: aSelector! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:42'!
replaceMethod: aSelector with: sourceCodeForNewMethod! !

!ClassIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:24'!
superclass: aClassMirror! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:25'!
definition! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:23'!
format! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:23'!
instSize! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:23'!
instSpec! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:32'!
instVarIndexFor: instVarName

	^ runTimeSupportMirror instVarIndexFor: instVarName forClass: baseObject ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:31'!
instVarNames

	^ (runTimeSupportMirror ivsForClass: baseObject) asLocalObject  ! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:24'!
isMetaclass! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:24'!
isVariable! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:24'!
methods! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
newInstance

	^ Reflection on: (runTimeSupportMirror newInstanceForClass: baseObject)! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:42'!
package! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:24'!
superclass! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:26'!
systemName! !

!ClassIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:25'!
typeOfClass! !

ObjectIntrospectionMirror subclass: #ContextIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ContextIntrospectionMirror subclass: #ContextIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ContextIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
tempNamed: aTempName put: anObject

	anObject isMirror ifTrue: [
		runTimeSupportMirror inContext: baseObject forTempNamed: aTempName put: anObject baseObject.
	] ifFalse: [
		runTimeSupportMirror inContext: baseObject forTempNamed: aTempName put: anObject.
	]! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:44'!
method! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:44'!
process! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:44'!
receiver! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:44'!
sender! !

!ContextIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
tempNamed: aTempName

	^ Reflection on: (runTimeSupportMirror tempNamed: aTempName inContext: baseObject).! !

ObjectIntrospectionMirror subclass: #EnvironmentIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

EnvironmentIntrospectionMirror subclass: #EnvironmentIntercessionMirror
	instanceVariableNames: 'exceptionCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
evaluate: aString onRemoteExceptionDo: aBlock

	|responce|
	
	
	responce := Reflection on: (runTimeSupportMirror evaluate: aString).
	responce class = ExceptionIntercessionMirror ifTrue: [
		[aBlock value: responce] fork.
	] ifFalse: [
		^ responce.
	]
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:29'!
globalAt: aName put: aMirror
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
newPackageNamed: aPackageName

	^ Reflection on: (runTimeSupportMirror newPackageNamed: aPackageName).
	
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 17:08'!
newRemoteException: anException
	
	Transcript show: anException class.
	exceptionCallback value: (Reflection on: anException) ! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
onRemoteExceptionDo: aBlock

	exceptionCallback := aBlock.
	runTimeSupportMirror registerExceptionListener: self! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:48'!
removePackageNamed: aPackageName
	
	! !

!EnvironmentIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
run: aString
	
	runTimeSupportMirror run: aString! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:48'!
environmentAddress

	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:28'!
globalAt: aName


	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:28'!
globals


	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:49'!
handleUpdate: anAnnouncement


	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:28'!
interruptedProcess


	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
packageNamed: aPackageNameAsString

	^ Reflection on: (runTimeSupportMirror packageNamed: aPackageNameAsString)
	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 11:01'!
packages


	
	! !

!EnvironmentIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:28'!
unhandledExceptions


	
	! !

ObjectIntrospectionMirror subclass: #ExceptionIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ExceptionIntrospectionMirror subclass: #ExceptionIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ExceptionIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:45'!
description! !

!ExceptionIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
interruptedProcess 

	^ Reflection on: (runTimeSupportMirror handlerProcessForException: baseObject)! !

ObjectIntrospectionMirror subclass: #MethodIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

MethodIntrospectionMirror subclass: #MethodIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:30'!
protocol! !

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:30'!
selector! !

!MethodIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:30'!
source! !

ObjectIntrospectionMirror subclass: #ObjectIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 09:28'!
changeClassTo: aClassName! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
objInstVarNamed: anIvName put: aValue

	aValue isMirror ifTrue: [
		runTimeSupportMirror vm_instVarOf: baseObject named: anIvName  put: aValue baseObject 			
	] ifFalse: [
		runTimeSupportMirror vm_instVarOf: baseObject named: anIvName  put: aValue 
	]

	! !

!ObjectIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
perform: aSelector withArguments: arguments onRemoteExceptionDo: aBlock
	
	|responce|
	
	
	responce := Reflection on: (runTimeSupportMirror perform: aSelector withReceiver: baseObject andArguments: arguments).
	responce class = ExceptionIntercessionMirror ifTrue: [
		[aBlock value: responce] fork.
	] ifFalse: [
		^ responce.
	]! !

!ObjectIntrospectionMirror class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:53'!
newWith: aBaseObject and: aRunTimeSupport

	^ self new
		initializeWith: aBaseObject and: aRunTimeSupport! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/5/2013 11:13'!
baseObject

	^ baseObject ! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:29'!
initializeWith: aBaseObject and: aRunTimeSupportMirror

	baseObject := aBaseObject.
	runTimeSupportMirror := aRunTimeSupportMirror.! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 09:05'!
instanceVariableNames 
	! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 12:15'!
isMirror

	^ true! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
objAsString
	
	^ runTimeSupportMirror vm_objAsStringFor: baseObject.! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/5/2013 11:10'!
objAt: anIndex
	! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/5/2013 11:10'!
objBasicSize
	! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:28'!
objClass

	^ Reflection on: (runTimeSupportMirror vm_classOf: baseObject)! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:28'!
objClassName

	^ Reflection on: (runTimeSupportMirror vm_classNameOf: baseObject)! !

!ObjectIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
objInstVarNamed: anIvName
	
	^ Reflection on: (runTimeSupportMirror vm_instVarOf: baseObject named: anIvName)! !

ObjectIntrospectionMirror subclass: #PackageIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

PackageIntrospectionMirror subclass: #PackageIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!PackageIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
newClassNamed: aNewClassName

	^ Reflection on: (runTimeSupportMirror newClassNamed: aNewClassName inPackage: baseObject)! !

!PackageIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
classNamed: aClassNameAsString

	^ Reflection on: (runTimeSupportMirror classNamed: aClassNameAsString inPackage: baseObject)! !

!PackageIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:31'!
classes! !

!PackageIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:31'!
packageName! !

ObjectIntrospectionMirror subclass: #ProcessIntrospectionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

ProcessIntrospectionMirror subclass: #ProcessIntercessionMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:35'!
into

	runTimeSupportMirror intoForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
over 

	runTimeSupportMirror overForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
proceed 

	runTimeSupportMirror proceedForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:47'!
recompileCurrentMethod: sourceCodeForMethod! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:36'!
restart

	runTimeSupportMirror restartForProcess: baseObject! !

!ProcessIntercessionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 15:36'!
thourgh

	runTimeSupportMirror throughForProcess: baseObject! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:28'!
contextAt: aContextIndex
	
	^ Reflection on: (runTimeSupportMirror contextAt: aContextIndex forProcess: baseObject)! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:31'!
home! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:31'!
method! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:31'!
methodClass! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:39'!
processName! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:32'!
receiver! !

!ProcessIntrospectionMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/14/2013 14:32'!
where! !

Mirror subclass: #RunTimeMirror
	instanceVariableNames: 'runTimeSupport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MetaLevel'!

!RunTimeMirror class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:44'!
newWith: aRunTimeSupport

	^ self new initializeWith: aRunTimeSupport ! !

!RunTimeMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:54'!
doesNotUnderstand: aMessage

	^ runTimeSupport perform: aMessage selector withArguments: aMessage arguments! !

!RunTimeMirror methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 13:44'!
initializeWith: aRunTimeSupport

	runTimeSupport := aRunTimeSupport ! !

Object subclass: #MyClass
	instanceVariableNames: 'myInstanceVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-MyProject'!

!Object methodsFor: '*Mercury-Prototype' stamp: 'NickPapoulias 1/9/2013 12:16'!
isMirror

	^ false! !

!Object methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/9/2013 10:45'!
xxx___isRemoteEnvironmentId 

	^ false! !

!Object methodsFor: '*Mercury-Prototype-DebuggingSeed' stamp: 'NickPapoulias 1/29/2013 12:12'!
xxx___runTimeDebuggingSupport 

	^ (Smalltalk globals at: #RunTimeDebuggingSupport) ! !

Object subclass: #ProcessSecurityPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-SecurityPolicy'!

ProcessSecurityPolicy subclass: #IntercessionSecurityPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-SecurityPolicy'!

!IntercessionSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 11:25'!
reflectionClasses

	^ {'Object' -> ObjectIntercessionMirror . 'Class' -> ClassIntercessionMirror . 'ContextPart' -> ContextIntercessionMirror . 'SystemDictionary' -> EnvironmentIntercessionMirror . 'Exception' -> ExceptionIntercessionMirror . 'CompiledMethod' -> MethodIntercessionMirror . 'PackageInfo' -> PackageIntercessionMirror . 'Process' -> ProcessIntercessionMirror} asDictionary ! !

!IntercessionSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:37'!
reflectionClasses

	^ {'Object' -> ObjectIntercessionMirror . 'Class' -> ClassIntercessionMirror . 'ContextPart' -> ContextIntercessionMirror . 'SystemDictionary' -> EnvironmentIntercessionMirror . 'Exception' -> ExceptionIntercessionMirror . 'CompiledMethod' -> MethodIntercessionMirror . 'PackageInfo' -> PackageIntercessionMirror . 'Process' -> ProcessIntercessionMirror} asDictionary ! !

ProcessSecurityPolicy subclass: #IntrospectionSecurityPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-SecurityPolicy'!

!IntrospectionSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 11:25'!
reflectionClasses

	^ {'Object' -> ObjectIntrospectionMirror . 'Class' -> ClassIntrospectionMirror . 'ContextPart' -> ContextIntrospectionMirror . 'SystemDictionary' -> EnvironmentIntrospectionMirror . 'Exception' -> ExceptionIntrospectionMirror . 'CompiledMethod' -> MethodIntrospectionMirror . 'PackageInfo' -> PackageIntrospectionMirror . 'Process' -> ProcessIntrospectionMirror} asDictionary ! !

!IntrospectionSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:38'!
reflectionClasses

	^ {'Object' -> ObjectIntrospectionMirror . 'Class' -> ClassIntrospectionMirror . 'ContextPart' -> ContextIntrospectionMirror . 'SystemDictionary' -> EnvironmentIntrospectionMirror . 'Exception' -> ExceptionIntrospectionMirror . 'CompiledMethod' -> MethodIntrospectionMirror . 'PackageInfo' -> PackageIntrospectionMirror . 'Process' -> ProcessIntrospectionMirror} asDictionary ! !

!ProcessSecurityPolicy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 11:25'!
reflectionClasses

	self subclassResponsibility ! !

!ProcessSecurityPolicy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/2/2013 10:36'!
reflectionClasses

	self subclassResponsibility ! !

Object subclass: #Reflection
	instanceVariableNames: ''
	classVariableNames: 'environmentMirrorsDict'
	poolDictionaries: ''
	category: 'Mercury-Prototype-ReflectionFactory'!

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/24/2013 13:20'!
authenticateOn: aRemoteEnvironment 

	"in the prototype authentication is handled automatically by the middleware,
	see SeamlessAuthenticationManager, this means that without the right credentials
	the middleware in the other side will not respond at the authenticate message send
	to the debugging seed"
	
	(aRemoteEnvironment = ('127.0.0.1' , SeamlessDeamonManager default defaultPort asString)) ifTrue: [
		^ self onLocalEnvironment. 
	].
	
	^ Reflection on: (DebuggingSeed from: aRemoteEnvironment target) authenticate
	! !

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/29/2013 14:16'!
on: anObject

	|kernelClassOfObject|
	
	anObject xxx___isRemoteEnvironmentId ifTrue: [
		^ self onEnvironment: anObject.
	].
	
	kernelClassOfObject := anObject xxx___runTimeDebuggingSupport vm_kernelClassOf: anObject.
	
	^ (Processor activeProcess reflectionPolicy reflectionClasses at: kernelClassOfObject)
		newWith: anObject and: anObject xxx___runTimeDebuggingSupport ! !

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:51'!
onEnvironment: aRemoteEnvironment

	^ self authenticateOn: aRemoteEnvironment 

	! !

!Reflection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 11:15'!
onLocalEnvironment

	^ Reflection on: Smalltalk globals

	! !

Object subclass: #RemoteEnvironment
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-ReflectionFactory'!

!RemoteEnvironment class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:48'!
@ aString

	^ self new target: aString! !

!RemoteEnvironment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:48'!
target

	^ target! !

!RemoteEnvironment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:48'!
target: aString
	
	target := aString! !

!RemoteEnvironment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 1/9/2013 10:47'!
xxx___isRemoteEnvironmentId 

	^ true! !

Object subclass: #RunTimeDebuggingSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Prototype-RunTimeDebuggingSupport'!

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/11/2013 12:29'!
addMethod: aString inClass: aClass

	aClass compile: aString

! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/9/2013 12:05'!
classNamed: aClassNameAsString inPackage: baseObject

	^ (baseObject classes select: [:class | class name = aClassNameAsString]) first! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:29'!
contextAt: aContextIndex forProcess: aProcess
	
	[aProcess handler = nil] whileTrue: []. "active waiting on handler installation"
	aProcess handler goToStackIndex: aContextIndex.
	^ aProcess handler currentContext.! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/10/2013 15:56'!
evaluate: aString

	|exception responce|

	[[responce := Compiler evaluate: aString] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[responce = nil & exception = nil] whileTrue: []. "active waiting on computation"

	^ responce ifNil: [exception]
! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 11:23'!
globalsDictionary

	^ Smalltalk globals! !

!RunTimeDebuggingSupport class methodsFor: 'exception' stamp: 'NickPapoulias 1/10/2013 13:16'!
handlerProcessForException: anException

	^ anException handlerProcess ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/9/2013 15:57'!
inContext: baseObject forTempNamed: aTempName put: anObject

	baseObject tempNamed: aTempName put: anObject! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:34'!
intoForProcess: aProcess 

	aProcess handler over

	! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 15:05'!
ivsForClass: aClass

	^ self vm_instVarOf: aClass at: 4.! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:30'!
kernelClasses

	^ {'Object'  . 'Class'  . 'ContextPart'  . 'SystemDictionary'  . 'Exception'  . 'CompiledMethod'  . 'PackageInfo'  . 'Process' } 
	! !

!RunTimeDebuggingSupport class methodsFor: 'misc' stamp: 'NickPapoulias 12/24/2012 17:04'!
metaLevelUpdate: aSystemAnnouncement! !

!RunTimeDebuggingSupport class methodsFor: 'package' stamp: 'NickPapoulias 1/11/2013 12:07'!
newClassNamed: aNewClassName inPackage: aPackage

	^ Object subclass: aNewClassName asSymbol  
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aPackage externalName. ! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/9/2013 12:08'!
newInstanceForClass: aClass

	"can be done through vm primitive"

	^ aClass new! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/11/2013 11:00'!
newPackageNamed: aPackageName

	^ PackageOrganizer default packageNamed: aPackageName ifAbsent: [(PackageInfo new packageName: aPackageName) register]! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/11/2013 10:37'!
overForProcess: aProcess 

	aProcess handler over

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:40'!
packageNamed: aPackageNameAsString 

	"this can be done through vm access in order to avoid local reflection dependency,
	after bootstraping the mirror hierarchy ideally this dependency is not needed"

	^ self packagesDictionary at: aPackageNameAsString ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/5/2013 10:44'!
packageNames

	^ PackageOrganizer default packageNames! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/13/2013 18:34'!
packages

	^ PackageOrganizer default packages ! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:39'!
packagesDictionary

	^ PackageOrganizer default instVarNamed: #packages! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/12/2013 19:47'!
perform: aSelector withReceiver: baseObject andArguments: arguments
	
	|exception responce args|

	arguments xxx___isProxy ifTrue: [
		args := arguments asLocalObject "better as shallowCopy"		
	] ifFalse: [
		args := arguments
	].

	[[responce := baseObject perform: aSelector withArguments: args] on: Exception do: [:ex | 
		exception := ex.
		ex debug.
	]] fork.

	[responce = nil & exception = nil] whileTrue: []. "active waiting on computation"

	^ responce ifNil: [exception]! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:34'!
proceedForProcess: aProcess 

	aProcess handler proceed 

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/24/2013 16:37'!
registerExceptionListener: aRequestor

	DebuggingSeed pushNewExceptionsTo: aRequestor.! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:35'!
restartForProcess: aProcess 

	aProcess handler restart

	! !

!RunTimeDebuggingSupport class methodsFor: 'environment' stamp: 'NickPapoulias 1/29/2013 12:15'!
run: aString

	[DebuggingSeed run: aString] fork. "will unload the RTSupport package"! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/11/2013 12:15'!
setIvs: ivs forClass: aClass

	self vm_instVarOf: aClass at: 4 put: ivs. ! !

!RunTimeDebuggingSupport class methodsFor: 'context' stamp: 'NickPapoulias 1/11/2013 10:42'!
tempNamed: aTempName inContext: aContext 

	^ aContext tempNamed: aTempName! !

!RunTimeDebuggingSupport class methodsFor: 'process' stamp: 'NickPapoulias 1/29/2013 15:35'!
throughForProcess: aProcess 

	aProcess handler through 

	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_basicSizeOf: anObject

	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. Do not 
	override in any subclass. See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:07'!
vm_changeClassTo: anotherClass of: anObject
	
	<primitive: 160 error: ec>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 12:45'!
vm_classNameOf: anObject

	(self vm_classOf: anObject) asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_classOf: anObject

	<primitive: 111>
	self primitiveFailed ! !

!RunTimeDebuggingSupport class methodsFor: 'misc' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_environment

	^ Smalltalk globals ! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:08'!
vm_indexedOf: anObject at: index
	<primitive: 60>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:09'!
vm_indexedOf: anObject at: index put: anotherObject
	<primitive: 61>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instSizeOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ ((cformat bitShift: -10) bitAnd: 16rC0) + ((cformat bitShift: -1) bitAnd: 16r3F) - 1
	! !

!RunTimeDebuggingSupport class methodsFor: 'class' stamp: 'NickPapoulias 1/29/2013 15:09'!
vm_instVarIndexOf: anIvName forClass: aClass

	| index |
	index := (self ivsForClass: aClass) == nil 
		ifTrue: [0]
		ifFalse: [(self ivsForClass: aClass) indexOf: anIvName].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [0]
			ifFalse: [self instVarIndexFor: anIvName forClass: superclass]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 13:05'!
vm_instVarNamesOf: anObject

	"this can be done via primitives"

	^ (self vm_classOf: anObject) instVarNames 
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index
	<primitive: 73>
	self primitiveFailed

	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_instVarOf: anObject at: index put: anotherObject
	<primitive: 74>
	self primitiveFailed
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 15:09'!
vm_instVarOf: anObject named: anIvName

	"this can be done via primitives"

	^ self vm_instVarOf: anObject at: (self vm_instVarIndexOf: anIvName forClass:  (self vm_classOf: anObject))
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/29/2013 15:12'!
vm_instVarOf: anObject named: anIvName put: aValue

	"this can be done via primitives"

	self vm_instVarOf: anObject 
		at: (self vm_instVarIndexOf: anIvName forClass:  (self vm_classOf: anObject)) 
		put: aValue
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:15'!
vm_kernelClassOf: anObject

	|classOfObject|

	classOfObject := self vm_classOf: anObject.
	
	[self kernelClasses includes: classOfObject asString] whileFalse: [
		classOfObject := self vm_instVarOf: classOfObject at: 1 "check the superclass"
	].

	^ classOfObject asString
		
	! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/9/2013 12:23'!
vm_objAsStringFor: baseObject

	^ baseObject asString! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_object: anObject equals: anotherObject

	<primitive: 110>
	self primitiveFailed! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectFormatOf: anObject

	"see behavior type of class"
	
	|class cformat|
	
	class := self vm_classOf: anObject.
	cformat := self vm_instVarOf: class at: 3.
	^ cformat! !

!RunTimeDebuggingSupport class methodsFor: 'object' stamp: 'NickPapoulias 1/2/2013 11:10'!
vm_objectTypeOf: anObject

	"see behavior type of class"
	
	|instSpec|
	
	instSpec := ((self vm_objectFormatOf: anObject) bitShift: -7) bitAnd: 16rF.
	instSpec = 12 ifTrue:[^#compiledMethod]. "Very special!!"
	instSpec >= 8 ifTrue:[^#bytes].
	((instSpec >= 8) not and:[(instSpec >= 6)]) ifTrue:[^#words].
	instSpec = 4 ifTrue:[^#weak].
	instSpec >= 2 ifTrue:[^#variable].
	^#normal.
	! !
MercurySeamlessDeamon initialize!
